unit EditPlugAPI;

interface
uses windows, EditPlugAPITypes, forms;

const exe = 'editplug.exe';

procedure epSetActiveEdSelText(p: pansichar); cdecl;
external exe;
function epGetActiveEdSelLen: longint; cdecl;
external exe;
function epGetActiveEdTextLen: longint; cdecl;
external exe;
function epGetActiveEdSelText(buf: pansichar; maxlen: longint): longint; cdecl;
external exe;
function epGetActiveEdText(buf: pansichar; len: longint): longint; cdecl;
external exe;

function epSetActiveEdSelStart(pos: longint): longbool; cdecl;
external exe;
function epSetActiveEdSelEnd(pos: longint): longbool; cdecl;
external exe;
function epGetActiveEdSelStart: longint; cdecl;
external exe;
function epGetActiveEdSelEnd: longint; cdecl;
external exe;

function epGetEdCount: longint; cdecl;
external exe;
function epGetEdIndex: longint; cdecl;
external exe;
function epSetActiveEd(idx: longint): longbool; cdecl;
external exe;
function epSetEdSelText(idx: longint; txt: pansichar): longbool; cdecl;
external exe;
function epSetEdText(idx: longint; txt: pansichar): longbool; cdecl;
external exe;
procedure epNewEd; cdecl;
external exe;
function epGetEdFileName(idx: longint; buf: pansichar; len: longint): longint; cdecl;
external exe;
function epGetEdFileNameLen(idx: longint): longint; cdecl;
external exe;
procedure epActiveEdRemoveSel; cdecl;
external exe;
procedure epSetParentToMainWin(child: HWND); cdecl;
external exe;
function epGetActiveEdFileNameLen: longint; cdecl;
external exe;
function epGetActiveEdFileName(buf: pansichar; len: longint): longint; cdecl;
external exe;
procedure epAddSearchResult(fname: pansichar; s: pansichar; coord: TBufCoord; len: longint); cdecl;
external exe;
procedure epClearSearchResults; cdecl;
external exe;
procedure epGetMainWinPos(out rslt: TWinPos); cdecl;
external exe;
function epGetMainWinHandle: HWND; cdecl;
external exe;
function epFilesModified: longbool; cdecl;
external exe;
function epFileModified(idx: longint): longbool; cdecl;
external exe;
procedure epSearchResultsBeginUpdate; cdecl;
external exe;
procedure epSearchResultsEndUpdate; cdecl;
external exe;
procedure epAppProcessMessages; cdecl;
external exe;
function epRemovePluginTab(plugid: HINST): longbool; cdecl;
external exe;
function epCreatePluginTab(plugid: HINST; winhandle: HWND): longbool; cdecl;
external exe;
function epCreatePluginTabEx(plugid: HINST; winhandle: HWND; adjustheight: longint): longbool; cdecl;
external exe;
procedure epSaveActiveEdFile; cdecl;
external exe;
procedure epSaveAllFiles; cdecl;
external exe;
function epGetActiveEdTmpHtmFileLen: longint; cdecl;
external exe;
function epGetActiveEdTmpHtmFile(buf: pansichar; len: longint): longint; cdecl;
external exe;
procedure epMakeActiveEdTmpHtmFile; cdecl;
external exe;
function epActiveEdUnnamed: longbool; cdecl;
external exe;
function epOpenFile(fname: pansichar): longbool; cdecl;
external exe;

function epGetEdSelStart(idx: longint): longint; cdecl;
external exe;
function epGetEdSelLen(idx: longint): longint; cdecl;
external exe;
function epGetEdSelEnd(idx: longint): longint; cdecl;
external exe;


function epGetEdTextLen(idx: longint): longint; cdecl;
external exe;
function epGetEdText(buf: pansichar; len: longint; idx: longint): longint; cdecl;
external exe;

function epSetEdSelStart(idx: longint; pos: longint): longbool; cdecl;
external exe;
function epSetEdSelEnd(idx: longint; pos: longint): longbool; cdecl;
external exe;

procedure epEdRemoveSel(idx: longint); cdecl;
external exe;

function epLoadPlugin(name: pansichar): longbool; cdecl;
external exe;

procedure epSetActiveEdFocus; cdecl;
external exe;
procedure epSetMainWinFocus; cdecl;
external exe;

function epGetActiveEdTextAsString: ansistring;
function epGetActiveEdSelTextAsString: ansistring;
function epGetActiveEdFilenameAsString: ansistring;
procedure epMoveWinToTopRight(form: TForm);
function epGetEdFileNameAsString(idx: integer): ansistring;
function epGetActiveEdTmpHtmFileAsString: ansistring;
function epGetEdTextAsString(idx: integer): ansistring;

function LibPath: ansistring;

implementation

function epGetActiveEdTextAsString: ansistring;
var
  len: integer;
  buffer: ansistring;
begin
  result := '';
  len := epGetActiveEdTextLen;
  if len < 1 then exit;
  setlength(buffer, len);
  epGetActiveEdText(pansichar(buffer), length(buffer)+1);
  buffer := pansichar(buffer);
  result := buffer;
end;

function epGetActiveEdSelTextAsString: ansistring;
var
  len: integer;
  buffer: ansistring;
begin
  result := '';
  len := epGetActiveEdSelLen;
  if len < 1 then exit;
  setlength(buffer, len);
  epGetActiveEdSelText(pansichar(buffer), length(buffer)+1);
  buffer := pansichar(buffer);
  result := buffer;
end;

function epGetActiveEdFileNameAsString: ansistring;
var
  len: integer;
  buffer: ansistring;
begin
  result := '';
  len := epGetActiveEdFileNameLen;
  if len < 1 then exit;
  setlength(buffer, len);
  epGetActiveEdFilename(pansichar(buffer), length(buffer)+1);
  buffer := pansichar(buffer);
  result := buffer;
end;

function epGetEdFileNameAsString(idx: integer): ansistring;
var
  len: integer;
  buffer: ansistring;
begin
  result := '';
  if idx < 0 then exit;
  len := epGetEdFileNameLen(idx);
  if len < 1 then exit;
  setlength(buffer, len);
  epGetEdFileName(idx, pansichar(buffer), length(buffer)+1);
  buffer := pansichar(buffer);
  result := buffer;
end;

procedure epMoveWinToTopRight(form: TForm);
var
  winpos: TWinPos;
  left: integer;
begin
  epGetMainWinPos(winpos);
  left := winpos.width - form.width - 10;
  MoveWindow(form.handle, left, 0, form.width, form.height, true);
end;


function LibPath: ansistring;
var
  Buffer: Array[0..260] of Char;
begin
  GetModuleFileName(hInstance, Buffer, Length(Buffer));
  result := buffer;
end;

function epGetActiveEdTmpHtmFileAsString: ansistring;
var
  len: integer;
  buffer: ansistring;
begin
  result := '';
  len := epGetActiveEdTmpHtmFileLen;
  if len < 1 then exit;
  setlength(buffer, len);
  epGetActiveEdTmpHtmFile(pansichar(buffer), length(buffer)+1);
  buffer := pansichar(buffer);
  result := buffer;
end;

function epGetEdTextAsString(idx: integer): ansistring;
var
  len: integer;
  buffer: ansistring;
begin
  result := '';
  len := epGetEdTextLen(idx);
  if len < 1 then exit;
  setlength(buffer, len);
  epGetEdText(pansichar(buffer), length(buffer)+1, idx);
  buffer := pansichar(buffer);
  result := buffer;
end;

end.
